<?xml version="1.0" encoding="UTF-8"?><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd"><html xmlns="http://www.w3.org/1999/xhtml" lang="en"><head><meta http-equiv="Content-Type" content="text/html;charset=UTF-8"/><link rel="stylesheet" href="../jacoco-resources/report.css" type="text/css"/><link rel="shortcut icon" href="../jacoco-resources/report.gif" type="image/gif"/><title>Util.java</title><link rel="stylesheet" href="../jacoco-resources/prettify.css" type="text/css"/><script type="text/javascript" src="../jacoco-resources/prettify.js"></script></head><body onload="window['PR_TAB_WIDTH']=4;prettyPrint()"><div class="breadcrumb" id="breadcrumb"><span class="info"><a href="../jacoco-sessions.html" class="el_session">Sessions</a></span><a href="../index.html" class="el_report">Code Coverage for Zookeeper manuall provided Classes</a> &gt; <a href="index.source.html" class="el_package">org.apache.zookeeper.server.persistence</a> &gt; <span class="el_source">Util.java</span></div><h1>Util.java</h1><pre class="source lang-java linenums">/**
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * &quot;License&quot;); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an &quot;AS IS&quot; BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.apache.zookeeper.server.persistence;

import java.io.ByteArrayOutputStream;
import java.io.EOFException;
import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.RandomAccessFile;
import java.io.Serializable;
import java.net.URI;
import java.nio.ByteBuffer;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;
import java.util.Comparator;
import java.util.List;
import java.util.Properties;

import org.apache.jute.BinaryOutputArchive;
import org.apache.jute.InputArchive;
import org.apache.jute.OutputArchive;
import org.apache.jute.Record;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.apache.zookeeper.txn.TxnHeader;

/**
 * A collection of utility methods for dealing with file name parsing, 
 * low level I/O file operations and marshalling/unmarshalling.
 */
<span class="nc" id="L49">public class Util {</span>
<span class="fc" id="L50">    private static final Logger LOG = LoggerFactory.getLogger(Util.class);</span>
    private static final String SNAP_DIR=&quot;snapDir&quot;;
    private static final String LOG_DIR=&quot;logDir&quot;;
    private static final String DB_FORMAT_CONV=&quot;dbFormatConversion&quot;;
<span class="fc" id="L54">    private static final ByteBuffer fill = ByteBuffer.allocateDirect(1);</span>
    
    public static String makeURIString(String dataDir, String dataLogDir, 
            String convPolicy){
<span class="nc" id="L58">        String uri=&quot;file:&quot;+SNAP_DIR+&quot;=&quot;+dataDir+&quot;;&quot;+LOG_DIR+&quot;=&quot;+dataLogDir;</span>
<span class="nc bnc" id="L59" title="All 2 branches missed.">        if(convPolicy!=null)</span>
<span class="nc" id="L60">            uri+=&quot;;&quot;+DB_FORMAT_CONV+&quot;=&quot;+convPolicy;</span>
<span class="nc" id="L61">        return uri.replace('\\', '/');</span>
    }
    /**
     * Given two directory files the method returns a well-formed 
     * logfile provider URI. This method is for backward compatibility with the
     * existing code that only supports logfile persistence and expects these two
     * parameters passed either on the command-line or in the configuration file.
     * 
     * @param dataDir snapshot directory
     * @param dataLogDir transaction log directory
     * @return logfile provider URI
     */
    public static URI makeFileLoggerURL(File dataDir, File dataLogDir){
<span class="nc" id="L74">        return URI.create(makeURIString(dataDir.getPath(),dataLogDir.getPath(),null));</span>
    }
    
    public static URI makeFileLoggerURL(File dataDir, File dataLogDir,String convPolicy){
<span class="nc" id="L78">        return URI.create(makeURIString(dataDir.getPath(),dataLogDir.getPath(),convPolicy));</span>
    }

    /**
     * Creates a valid transaction log file name. 
     * 
     * @param zxid used as a file name suffix (extention)
     * @return file name
     */
    public static String makeLogName(long zxid) {
<span class="nc" id="L88">        return &quot;log.&quot; + Long.toHexString(zxid);</span>
    }

    /**
     * Creates a snapshot file name.
     * 
     * @param zxid used as a suffix
     * @return file name
     */
    public static String makeSnapshotName(long zxid) {
<span class="fc" id="L98">        return &quot;snapshot.&quot; + Long.toHexString(zxid);</span>
    }
    
    /**
     * Extracts snapshot directory property value from the container.
     * 
     * @param props properties container
     * @return file representing the snapshot directory
     */
    public static File getSnapDir(Properties props){
<span class="nc" id="L108">        return new File(props.getProperty(SNAP_DIR));</span>
    }

    /**
     * Extracts transaction log directory property value from the container.
     * 
     * @param props properties container
     * @return file representing the txn log directory
     */
    public static File getLogDir(Properties props){
<span class="nc" id="L118">        return new File(props.getProperty(LOG_DIR));</span>
    }
    
    /**
     * Extracts the value of the dbFormatConversion attribute.
     * 
     * @param props properties container
     * @return value of the dbFormatConversion attribute
     */
    public static String getFormatConversionPolicy(Properties props){
<span class="nc" id="L128">        return props.getProperty(DB_FORMAT_CONV);</span>
    }
   
    /**
     * Extracts zxid from the file name. The file name should have been created
     * using one of the {@link makeLogName} or {@link makeSnapshotName}.
     * 
     * @param name the file name to parse
     * @param prefix the file name prefix (snapshot or log)
     * @return zxid
     */
    public static long getZxidFromName(String name, String prefix) {
<span class="fc" id="L140">        long zxid = -1;</span>
<span class="fc" id="L141">        String nameParts[] = name.split(&quot;\\.&quot;);</span>
<span class="fc bfc" id="L142" title="All 4 branches covered.">        if (nameParts.length == 2 &amp;&amp; nameParts[0].equals(prefix)) {</span>
            try {
<span class="fc" id="L144">                zxid = Long.parseLong(nameParts[1], 16);</span>
<span class="nc" id="L145">            } catch (NumberFormatException e) {</span>
<span class="fc" id="L146">            }</span>
        }
<span class="fc" id="L148">        return zxid;</span>
    }

    /**
     * Verifies that the file is a valid snapshot. Snapshot may be invalid if 
     * it's incomplete as in a situation when the server dies while in the process
     * of storing a snapshot. Any file that is not a snapshot is also 
     * an invalid snapshot. 
     * 
     * @param f file to verify
     * @return true if the snapshot is valid
     * @throws IOException
     */
    public static boolean isValidSnapshot(File f) throws IOException {
<span class="pc bpc" id="L162" title="1 of 4 branches missed.">        if (f==null || Util.getZxidFromName(f.getName(), &quot;snapshot&quot;) == -1)</span>
<span class="fc" id="L163">            return false;</span>

        // Check for a valid snapshot
<span class="fc" id="L166">        RandomAccessFile raf = new RandomAccessFile(f, &quot;r&quot;);</span>
        try {
            // including the header and the last / bytes
            // the snapshot should be atleast 10 bytes
<span class="fc bfc" id="L170" title="All 2 branches covered.">            if (raf.length() &lt; 10) {</span>
<span class="fc" id="L171">                return false;</span>
            }
<span class="fc" id="L173">            raf.seek(raf.length() - 5);</span>
<span class="fc" id="L174">            byte bytes[] = new byte[5];</span>
<span class="fc" id="L175">            int readlen = 0;</span>
            int l;
<span class="fc bfc" id="L177" title="All 2 branches covered.">            while(readlen &lt; 5 &amp;&amp;</span>
<span class="pc bpc" id="L178" title="1 of 2 branches missed.">                  (l = raf.read(bytes, readlen, bytes.length - readlen)) &gt;= 0) {</span>
<span class="fc" id="L179">                readlen += l;</span>
            }
<span class="pc bpc" id="L181" title="1 of 2 branches missed.">            if (readlen != bytes.length) {</span>
<span class="nc" id="L182">                LOG.info(&quot;Invalid snapshot &quot; + f</span>
                        + &quot; too short, len = &quot; + readlen);
<span class="nc" id="L184">                return false;</span>
            }
<span class="fc" id="L186">            ByteBuffer bb = ByteBuffer.wrap(bytes);</span>
<span class="fc" id="L187">            int len = bb.getInt();</span>
<span class="fc" id="L188">            byte b = bb.get();</span>
<span class="pc bpc" id="L189" title="2 of 4 branches missed.">            if (len != 1 || b != '/') {</span>
<span class="nc" id="L190">                LOG.info(&quot;Invalid snapshot &quot; + f + &quot; len = &quot; + len</span>
                        + &quot; byte = &quot; + (b &amp; 0xff));
<span class="nc" id="L192">                return false;</span>
            }
<span class="fc" id="L194">        } finally {</span>
<span class="nc" id="L195">            raf.close();</span>
<span class="fc" id="L196">        }</span>

<span class="pc" id="L198">        return true;</span>
    }

    /**
     * Grows the file to the specified number of bytes. This only happenes if 
     * the current file position is sufficiently close (less than 4K) to end of 
     * file. 
     * 
     * @param f output stream to pad
     * @param currentSize application keeps track of the cuurent file size
     * @param preAllocSize how many bytes to pad
     * @return the new file size. It can be the same as currentSize if no
     * padding was done.
     * @throws IOException
     */
    public static long padLogFile(FileOutputStream f,long currentSize,
            long preAllocSize) throws IOException{
<span class="fc" id="L215">        long position = f.getChannel().position();</span>
<span class="fc bfc" id="L216" title="All 2 branches covered.">        if (position + 4096 &gt;= currentSize) {</span>
<span class="fc" id="L217">            currentSize = currentSize + preAllocSize;</span>
<span class="fc" id="L218">            fill.position(0);</span>
<span class="fc" id="L219">            f.getChannel().write(fill, currentSize-fill.remaining());</span>
        }
<span class="fc" id="L221">        return currentSize;</span>
    }

    /**
     * Reads a transaction entry from the input archive.
     * @param ia archive to read from
     * @return null if the entry is corrupted or EOF has been reached; a buffer
     * (possible empty) containing serialized transaction record.
     * @throws IOException
     */
    public static byte[] readTxnBytes(InputArchive ia) throws IOException {
        try{
<span class="fc" id="L233">            byte[] bytes = ia.readBuffer(&quot;txtEntry&quot;);</span>
            // Since we preallocate, we define EOF to be an
            // empty transaction
<span class="fc bfc" id="L236" title="All 2 branches covered.">            if (bytes.length == 0)</span>
<span class="fc" id="L237">                return bytes;</span>
<span class="pc bpc" id="L238" title="1 of 2 branches missed.">            if (ia.readByte(&quot;EOF&quot;) != 'B') {</span>
<span class="nc" id="L239">                LOG.error(&quot;Last transaction was partial.&quot;);</span>
<span class="nc" id="L240">                return null;</span>
            }
<span class="fc" id="L242">            return bytes;</span>
<span class="nc" id="L243">        }catch(EOFException e){}</span>
<span class="nc" id="L244">        return null;</span>
    }
    

    /**
     * Serializes transaction header and transaction data into a byte buffer.
     *  
     * @param hdr transaction header
     * @param txn transaction data
     * @return serialized transaction record
     * @throws IOException
     */
    public static byte[] marshallTxnEntry(TxnHeader hdr, Record txn)
            throws IOException {
<span class="fc" id="L258">        ByteArrayOutputStream baos = new ByteArrayOutputStream();</span>
<span class="fc" id="L259">        OutputArchive boa = BinaryOutputArchive.getArchive(baos);</span>

<span class="fc" id="L261">        hdr.serialize(boa, &quot;hdr&quot;);</span>
<span class="fc bfc" id="L262" title="All 2 branches covered.">        if (txn != null) {</span>
<span class="fc" id="L263">            txn.serialize(boa, &quot;txn&quot;);</span>
        }
<span class="fc" id="L265">        return baos.toByteArray();</span>
    }

    /**
     * Write the serialized transaction record to the output archive.
     *  
     * @param oa output archive
     * @param bytes serialized trasnaction record
     * @throws IOException
     */
    public static void writeTxnBytes(OutputArchive oa, byte[] bytes)
            throws IOException {
<span class="fc" id="L277">        oa.writeBuffer(bytes, &quot;txnEntry&quot;);</span>
<span class="fc" id="L278">        oa.writeByte((byte) 0x42, &quot;EOR&quot;); // 'B'</span>
<span class="fc" id="L279">    }</span>
    
    
    /**
     * Compare file file names of form &quot;prefix.version&quot;. Sort order result
     * returned in order of version.
     */
<span class="nc" id="L286">    private static class DataDirFileComparator</span>
        implements Comparator&lt;File&gt;, Serializable
    {
        private static final long serialVersionUID = -2648639884525140318L;

        private String prefix;
        private boolean ascending;
<span class="fc" id="L293">        public DataDirFileComparator(String prefix, boolean ascending) {</span>
<span class="fc" id="L294">            this.prefix = prefix;</span>
<span class="fc" id="L295">            this.ascending = ascending;</span>
<span class="fc" id="L296">        }</span>

        public int compare(File o1, File o2) {
<span class="fc" id="L299">            long z1 = Util.getZxidFromName(o1.getName(), prefix);</span>
<span class="fc" id="L300">            long z2 = Util.getZxidFromName(o2.getName(), prefix);</span>
<span class="fc bfc" id="L301" title="All 4 branches covered.">            int result = z1 &lt; z2 ? -1 : (z1 &gt; z2 ? 1 : 0);</span>
<span class="fc bfc" id="L302" title="All 2 branches covered.">            return ascending ? result : -result;</span>
        }
    }
    
    /**
     * Sort the list of files. Recency as determined by the version component
     * of the file name.
     *
     * @param files array of files
     * @param prefix files not matching this prefix are assumed to have a
     * version = -1)
     * @param ascending true sorted in ascending order, false results in
     * descending order
     * @return sorted input files
     */
    public static List&lt;File&gt; sortDataDir(File[] files, String prefix, boolean ascending)
    {
<span class="pc bpc" id="L319" title="1 of 2 branches missed.">        if(files==null)</span>
<span class="nc" id="L320">            return new ArrayList&lt;File&gt;(0);</span>
<span class="fc" id="L321">        List&lt;File&gt; filelist = Arrays.asList(files);</span>
<span class="fc" id="L322">        Collections.sort(filelist, new DataDirFileComparator(prefix, ascending));</span>
<span class="fc" id="L323">        return filelist;</span>
    }
    
}
</pre><div class="footer"><span class="right">Created with <a href="http://www.eclemma.org/jacoco">JaCoCo</a> 0.7.7.201606060606</span></div></body></html>